## netperfmeter-1.7.3.tar.gz

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(netperfmeter)

set(BUILD_MAJOR "1")
set(BUILD_MINOR "7")
set(BUILD_PATCH "3")
set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})


#################################################
# INSTALLATION_DIRECTORIES
#################################################

SET(CMAKE_INSTALL_BINDIR_DOC        "user executables [PREFIX/bin]")
SET(CMAKE_INSTALL_SBINDIR_DOC       "system admin executables [EPREFIX/sbin]")
SET(CMAKE_INSTALL_DATADIR_DOC       "read-only architecture-independent data [PREFIX/share]")
SET(CMAKE_INSTALL_SYSCONFDIR_DOC    "read-only single-machine data [PREFIX/etc]")
SET(CMAKE_INSTALL_LOCALSTATEDIR_DOC "modifiable single-machine data [PREFIX/var]")
SET(CMAKE_INSTALL_LIBDIR_DOC        "object code libraries [PREFIX/lib]")
SET(CMAKE_INSTALL_INCLUDEDIR_DOC    "read-only includes [PREFIX/include]")
SET(CMAKE_INSTALL_MANDIR_DOC        "man documentation [PREFIX/share/man]")

SET(CMAKE_INSTALL_BINDIR "bin"
    CACHE PATH ${CMAKE_INSTALL_BINDIR_DOC})
SET(CMAKE_INSTALL_SBINDIR "sbin"
    CACHE PATH ${CMAKE_INSTALL_SBINDIR_DOC})
SET(CMAKE_INSTALL_DATADIR "share"
    CACHE PATH ${CMAKE_INSTALL_DATADIR_DOC})
SET(CMAKE_INSTALL_SYSCONFDIR "etc"
    CACHE PATH ${CMAKE_INSTALL_SYSCONFDIR_DOC})
SET(CMAKE_INSTALL_LOCALSTATEDIR "var"
    CACHE PATH ${CMAKE_INSTALL_LOCALSTATEDIR_DOC})
SET(CMAKE_INSTALL_LIBDIR "lib"
    CACHE PATH ${CMAKE_INSTALL_LIBDIR_DOC})
SET(CMAKE_INSTALL_INCLUDEDIR "include"
    CACHE PATH ${CMAKE_INSTALL_INCLUDEDIR_DOC})
SET(CMAKE_INSTALL_MANDIR "share/man"
    CACHE PATH ${CMAKE_INSTALL_MANDIR_DOC})


#################################################
# PACKAGING
#################################################

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
   "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
   "${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}-*;${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}_*;/build/;/.git/;/config.log;/CMakeFiles/;CMakeCache.txt$;.cmake$;.tar.gz$;/_CPack_Packages;/Makefile$;~$;/build-deb;/clean-deb;/filter-empty-entries;/make-symbols;/make-ppa;/make-deb;/debian.conf;/make-rpm;/rpm.conf;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


INCLUDE(CheckIncludeFile)
INCLUDE(CheckStructHasMember)


#################################################
# OS DEPENDENT
#################################################

SET(CMAKE_MACOSX_RPATH 1)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    ADD_DEFINITIONS("-D_DEFAULT_SOURCE -DLINUX")
    ADD_DEFINITIONS("-DHAVE_MPTCP")   # Any better solution for this?
    FIND_LIBRARY(SCTP_LIB sctp)

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include")
    ADD_DEFINITIONS("-DFreeBSD")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")
    ADD_DEFINITIONS("-DDARWIN")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    LIST(APPEND neat_headers neat_bsd.h)
    LIST(APPEND neat_sources neat_bsd.c)
    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")
    ADD_DEFINITIONS("-DNetBSD")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    ADD_DEFINITIONS("-DSOLARIS")

ELSE()
    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()

find_package(Threads REQUIRED)


#################################################
# CHECK STRUCT MEMBERS
#################################################

CHECK_STRUCT_HAS_MEMBER("struct sockaddr" "sa_len" "sys/types.h;sys/socket.h" HAVE_SA_LEN)
IF (HAVE_SA_LEN)
    MESSAGE(STATUS "HAVE_SA_LEN")
    ADD_DEFINITIONS(-DHAVE_SA_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in" "sin_len" "sys/types.h;netinet/in.h" HAVE_SIN_LEN)
IF (HAVE_SIN_LEN)
    MESSAGE(STATUS "HAVE_SIN_LEN")
    ADD_DEFINITIONS(-DHAVE_SIN_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in6" "sin6_len" "sys/types.h;netinet/in.h" HAVE_SIN6_LEN)
IF (HAVE_SIN6_LEN)
    MESSAGE(STATUS "HAVE_SIN6_LEN")
    ADD_DEFINITIONS(-DHAVE_SIN6_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_storage" "ss_len" "sys/types.h;sys/socket.h" HAVE_SS_LEN)
IF (HAVE_SS_LEN)
    MESSAGE(STATUS "HAVE_SS_LEN")
    ADD_DEFINITIONS(-DHAVE_SS_LEN)
ENDIF()


#################################################
# CHECK OPTIONS
#################################################

# Debug build type as default
IF (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, using DEBUG")
    set(CMAKE_BUILD_TYPE "DEBUG")
    # _FORTIFY_SOURCE requires compiling with optimization
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O")
endif()


#################################################
# REQUIREMENTS
#################################################

OPTION(BUILD_TEST_PROGRAMS "Build test programs" 0)
OPTION(BUILD_PLOT_PROGRAMS "Build plot programs" 0)


# ###### SCTP ###############################################################
OPTION(USE_KERNEL_SCTP "Use Kernel SCTP" 1)
IF (USE_KERNEL_SCTP)
   # ====== Kernel SCTP =====================================================
   CHECK_INCLUDE_FILE(netinet/sctp.h HAVE_NETINET_SCTP_H)
   IF (HAVE_NETINET_SCTP_H)
      SET(SCTP_INCLUDE "netinet/sctp.h")
      ADD_DEFINITIONS(-DHAVE_KERNEL_SCTP -DHAVE_NETINET_SCTP_H)
   ENDIF()

ELSE()
   # ====== SCTPLIB User-Space SCTP =========================================
   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPLIB_SCTP_H)
   FIND_LIBRARY(SCTPLIB_LIB sctplib)
   MESSAGE(STATUS "sctplib found: ${SCTPLIB_LIB}")
   IF (NOT HAVE_SCTPLIB_SCTP_H OR NOT SCTPLIB_LIB)
      MESSAGE(FATAL_ERROR "sctplib not found - libsctplib installed?")
   ENDIF()

   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPSOCKET_SCTP_H)
   FIND_LIBRARY(SCTPSOCKET_LIB sctpsocket)
   MESSAGE(STATUS "sctpsocket found: ${SCTPSOCKET_LIB}")
   IF (NOT HAVE_SCTPSOCKET_SCTP_H OR NOT SCTPSOCKET_LIB)
      MESSAGE(FATAL_ERROR "sctpsocket not found - libsctpsocket installed?")
   ENDIF()
   
   FIND_PACKAGE(PkgConfig)
   PKG_CHECK_MODULES(GLIB glib-2.0)
   IF (NOT ${GLIB_LIBS})
      MESSAGE(FATAL_ERROR "glib not found - glib-2.0 installed?")
   ENDIF()

   SET(SCTP_LIB ${SCTPSOCKET_LIB} ${SCTPLIB_LIB} ${GLIB_LIBRARIES})
ENDIF()


# ###### NEAT ###############################################################
OPTION(WITH_NEAT "Include NEAT support" 0)
IF (WITH_NEAT)
   CHECK_INCLUDE_FILE(neat-socketapi.h HAVE_NEAT_SOCKETAPI_H)
   FIND_LIBRARY(NEAT_SOCKETAPI_LIB neat-socketapi)
   MESSAGE(STATUS "neat-socketapi found: ${NEAT_SOCKETAPI_LIB}")
   IF (NOT HAVE_NEAT_SOCKETAPI_H OR NOT NEAT_SOCKETAPI_LIB)
      MESSAGE(FATAL_ERROR "neat-socketapi not found - neat-socketapi installed?")
   ENDIF()
ENDIF()


# ###### BZip2 ##############################################################
find_package(BZip2 REQUIRED)


# ###### IEEE Floating-Point ################################################
include(CheckCSourceRuns)
check_c_source_runs("
#include <stdio.h>

union DoubleIntUnion
{
   double             Double;
   unsigned long long Integer;
};

int main (int argc, char** argv)
{
   union DoubleIntUnion value;

   value.Double = 0.0;
   if(value.Integer != 0ULL) {
      return(1);
   }
   value.Double = 1000.5;
   if(value.Integer != 0x408f440000000000ULL) {
      return(1);
   }
   value.Double = -1000.5;
   if(value.Integer != 0xc08f440000000000ULL) {
      return(1);
   }

   return(0);
}"
USES_IEEEFP_FP)

IF (USES_IEEEFP_FP)
   ADD_DEFINITIONS(-DHAVE_IEEE_FP)
ENDIF()


#################################################
# COMPILER FLAGS
#################################################

SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -std=c11   -Wall -Wno-unused-function -Wno-unused-parameter -Wno-overlength-strings -Wno-array-bounds")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wno-unused-function -Wno-unused-parameter -Wno-overlength-strings -Wno-array-bounds")

IF (CMAKE_BUILD_TYPE MATCHES DEBUG)
    MESSAGE(STATUS "Building in DEBUG mode")
    # _FORTIFY_SOURCE requires compiling with optimization
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O")
ENDIF()


#################################################
# INCLUDE EXAMPLES
#################################################

ADD_SUBDIRECTORY(src)

=== debian/changelog ===
netperfmeter (1.7.3-1ubuntu1) xenial; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Tue, 08 Aug 2017 08:08:08 +0200

netperfmeter (1.7.2-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/watch: fixed URL.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 07 Aug 2017 08:08:08 +0200

netperfmeter (1.7.1-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/rules: autoconf/automake -> cmake
  * debian/control: autoconf/automake -> cmake

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 07 Aug 2017 08:08:08 +0200

netperfmeter (1.7.0-1ubuntu1) zesty; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Thu, 20 Apr 2017 08:08:08 +0200

netperfmeter (1.6.1-1ubuntu1) zesty; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 04 Nov 2016 08:08:08 +0200

netperfmeter (1.6.0-1ubuntu1) yakkety; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 17 Aug 2016 08:08:08 +0200

netperfmeter (1.5.6-1ubuntu1) yakkety; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 29 Apr 2016 08:08:08 +0200

netperfmeter (1.5.5-1ubuntu1) wily; urgency=low

  * New upstream version.
  * debian/control: Updated standards version.
  * debian/control: added dependency dpkg-dev for hardening options.
  * debian/copyright: fix for machine-readable format.
  * debian/rules: using buildflags.mk for hardening options.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 04 Apr 2016 08:08:08 +0200

netperfmeter (1.5.4-1ubuntu1) vivid; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 11 May 2015 08:08:08 +0200

netperfmeter (1.5.3-1ubuntu1) vivid; urgency=low

  * New upstream version.
  * debian/copyright: changed to machine-readable format.
  * debian/control: updated standards version.
  * debian/watch: added pgpsigurlmangle option.
  * debian/upstream/signing-key.asc: added upstream public key.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 01 Mar 2015 08:08:08 +0200

netperfmeter (1.5.2-1ubuntu1) vivid; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Thu, 05 Feb 2015 08:08:08 +0200

netperfmeter (1.5.0-1ubuntu1) utopic; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 14 Nov 2014 08:08:08 +0200

netperfmeter (1.4.0-1ubuntu1) utopic; urgency=low

  * New upstream version.
  * debian/control: Added libfile-fcntllock-perl to get rid of
                    warning on NFS-safe locks.
  * debian/control: Added bc as dependency.
                    Updated standards version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 28 Jul 2014 08:08:08 +0200

netperfmeter (1.3.0-1ubuntu1) quantal; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 21 Dec 2012 23:23:23 +0200

netperfmeter (1.2.4-1ubuntu1) quantal; urgency=low

  * New upstream version.
  * debian/control: added colorgcc as build dependency.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 15 Jul 2012 12:12:12 +0200

netperfmeter (1.2.3-1ubuntu1) precise; urgency=low

  * New upstream version.
  * Removed gcc-4.7 patch, since changes are included upstream now.
  * debian/control: update for debhelper 9.
  * debian/control: added libglib2.0-dev build dependency.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 01 Jul 2012 22:22:22 +0800

netperfmeter (1.1.7-1.1ubuntu1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-4.7": add patch gcc-4.7.patch (missing includes).
    (Closes: #667295)

 -- gregor herrmann <gregoa@debian.org>  Thu, 10 May 2012 23:55:03 +0200

netperfmeter (1.1.7-1ubuntu1) unstable; urgency=low

  * New upstream version.
  * Changed package format to 3.0 (quilt).

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sat, 12 Feb 2011 11:11:11 +0200

netperfmeter (1.1.0-1ubuntu1) maverick; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 03 Dec 2010 12:12:12 +0200

netperfmeter (1.0.4-1ubuntu1) maverick; urgency=low

  * New upstream version.
  * Removed "conflict" and "replaces" to netmeter (old name of
    netperfmeter).

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 21 Jul 2010 15:22:22 +0200

netperfmeter (1.0.3-3ubuntu1) maverick; urgency=low

  * Removed recommended package not being available in Debian.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 02 Jul 2010 14:46:18 +0200

netperfmeter (1.0.3-2ubuntu1) maverick; urgency=low

  * Closes Debian ITP bug with wnpp (Closes: #546738).
  * Initial Ubuntu package (LP: #430012).
  * Switch to dpkg-source 3.0 (quilt) format

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 27 Jun 2010 12:27:40 +0200

=== debian/control ===
Source: netperfmeter
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <dreibh@iem.uni-due.de>
Homepage: http://www.iem.uni-due.de/~dreibh/netperfmeter/
Build-Depends: cmake,
               debhelper (>= 9),
               libbz2-dev (>= 1.0),
               libfile-fcntllock-perl,
               libsctp-dev (>= 1.0.5)
Standards-Version: 3.9.7

Package: pdfproctools
Architecture: all
Depends: ghostscript,
         libpdf-api2-perl,
         perl (>= 5.8.0),
         qpdf,
         ${misc:Depends},
         ${shlibs:Depends}
Description: PDF Processing Tools
 This package contains tools for PDF file processing.
 .
 PDFMetadata updates the metadata of a PDF file. In particular, it can be
 used to add outlines (bookmarks) to a document. Furthermore, it can set the
 document properties (e.g. author, title, keywords, creator, producer).
 .
 PDFEmbedFonts embeds all referenced fonts into a PDF file. Optionally, it
 can also linearize the PDF file for online publication
 ("fast web view", "optimized").

Package: netperfmeter-plotting
Architecture: all
Depends: pdfproctools,
         r-base,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Network Performance Meter (plotting program)
 NetPerfMeter is a network performance meter for the UDP,
 TCP, MPTCP, SCTP and DCCP transport protocols over IPv4 and IPv6.
 It simultaneously transmits bidirectional flows to an endpoint
 and measures the resulting flow bandwidths and QoS. The
 results are written as vector and scalar files. The vector
 files can e.g. be used to create plots of the results.
 .
 This package contains a plotting program for the results.

Package: netperfmeter
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: bc,
            iputils-ping,
            iputils-tracepath,
            netperfmeter-plotting,
            subnetcalc (>= 2.0.2),
            traceroute
Description: Network Performance Meter (measurement program)
 NetPerfMeter is a network performance meter for the UDP,
 TCP, MPTCP, SCTP and DCCP transport protocols over IPv4 and IPv6.
 It simultaneously transmits bidirectional flows to an endpoint
 and measures the resulting flow bandwidths and QoS. The
 results are written as vector and scalar files. The vector
 files can e.g. be used to create plots of the results.
 .
 This package contains the measurement program.
